## Correlation Tracking via Joint Discrimination and Reliability Learning (DRT)

### Introduction
This package contains the source code to reproduce the experimental results of DRT. The source code is mainly written in MATLAB with a modifed Caffe framework.

### Usage

* Supported OS: the source code was tested on 64-bit Ubuntu 14.04 Linux OS, and it should also be executable in other linux distributions.

* Dependencies: 
 * A modified version of [caffe](http://caffe.berkeleyvision.org/) framework (included in the ./DRT/caffe folder) and all its dependencies.
 * Cuda enabled GPUs

* Installation: 
 1. Install caffe: we use a modified version of the original caffe framework. Compile the source code in the ./DRT/caffe directory and the matlab interface following the [installation instruction of caffe](http://caffe.berkeleyvision.org/installation.html). Compile the Matconvnet by running ./DRT/matconvnet/matlab/vl_compilenn.m.
 2. Download the 16-layer VGG network from https://gist.github.com/ksimonyan/211839e770f7b538e2d8, and put the caffemodel file under the ./DRT/model directory.
 3. Download the VGG-M network (imagenet-vgg-m-2048) from http://www.vlfeat.org/matconvnet/pretrained/, and put the mat file under the ./DRT/networks directory. Note that we do not use the VGG-M as the feature of our tracker. We need VGG-M model to make the feature extraction code of CCOT executable.
 4. Properly configure the code (see blow), and run ./vot-toolkit-master/wworkspace/run_experiments.m


### Settings

To run the codes, users should revise the directories in the file:
./set_tracker_param1.m
./model/cnn-a_solver.prototxt
./model/cnn-third_solver.prototxt
./model/dtpooling_solver.prototxt
./model/feature_solver.prototxt
 

### Contact
waynecool@mail.dlut.edu.cn


### Liscense

        Copyright (c) 2018, Chong Sun
        All rights reserved. 
        Redistribution and use in source and binary forms, with or without modification, are 
        permitted provided that the following conditions are met:
    		* Redistributions of source code must retain the above copyright 
      		  notice, this list of conditions and the following disclaimer.
    		* Redistributions in binary form must reproduce the above copyright 
      		  notice, this list of conditions and the following disclaimer in 
      		  the documentation and/or other materials provided with the distribution
        
        THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
        AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
        IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
        ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE 	
        LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
        CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
        SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
        INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
        CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
        ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
        POSSIBILITY OF SUCH DAMAGE.

